﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Public ivBackground As B4XView
	Private PanelForTouch As B4XView
	Public lblStats As B4XView
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	Public RightDown, LeftDown, JumpDown, DownDown, UpDown As Boolean
	Private Tank As X2BodyWrapper

	Private TankMovementForce As B2Vec2
	
	Public GroundLevel As Float
	
	Private BrushLineColor1 As BCBrush
	
	Dim WorldHeight As Float
	Dim WorldWidth As Float
	

End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, -20))
	X2.Initialize(Me, ivForeground, world)
	WorldHeight = 40 '
	WorldWidth  = WorldHeight * 1.3333
	
	X2.ConfigureDimensions(world.CreateVec2(WorldWidth / 2, WorldHeight / 2), WorldHeight * 1.16) '<------ lower Then 1.15 will produce the error
	
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	
	
	'comment to disable debug drawing
'	X2.EnableDebugDraw

	TileMap.Initialize(X2, File.DirAssets, "tank.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldHeight / TileMap.TilesPerColumn, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	
'	TileMap.SetBackgroundColor(0xFF008AFF)  ' <--------------------- first error when uncommented
	
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		If template.Name <> "hinge" Then 
			Dim bw As X2BodyWrapper = TileMap.CreateObject(template)
			If bw.Name = "tank" Then 
				Tank = bw
			End If
		End If
	Next
	
	
	TankMovementForce = X2.CreateVec2(12,0)
	
	GroundLevel = X2.ScreenAABB.BottomLeft.Y 
	
	BrushLineColor1 = X2.MainBC.CreateBrushFromColor(xui.Color_LightGray)
	
	X2.Start
End Sub


Public Sub Tick (GS As X2GameStep)
	If UpDown Then

	Else If DownDown Then

	Else

	End If
	
	If RightDown Then
		Tank.Body.ApplyLinearImpulse(TankMovementForce, Tank.Body.Position)
		Tank.SwitchFrameIntervalMs = 100
	Else If LeftDown Then
		Tank.Body.ApplyLinearImpulse(TankMovementForce.Negate, Tank.Body.Position)
		Tank.SwitchFrameIntervalMs = 100
	Else
		Tank.SwitchFrameIntervalMs = 0
	End If
	'

	'
	'
	If GS.ShouldDraw Then
		Dim bw As X2BodyWrapper = X2.GetBodyWrapperByName("tank")
		
		Dim v As B2Vec2 = bw.Body.WorldCenter
		v = ClipScreenCenterToMapArea(v.CreateCopy) ' nur eine Kopie(!) des Vektors übergeben

		X2.UpdateWorldCenter(v)
		
		For Each body As B2Body In world.AllBodies
			Dim bw As X2BodyWrapper = body.Tag
			If bw.Name.Contains("block") Then
				myTransform(GS, bw)
			End If
		Next
	End If
	
	
End Sub


Sub ClipScreenCenterToMapArea (v As B2Vec2) As B2Vec2
	Dim ScreenHalfWidth As Float = X2.ScreenAABB.Width / 2
	Dim ScreenHalfHeight As Float = X2.ScreenAABB.Height / 2
	v.X = Max(ScreenHalfWidth, Min(TileMap.MapAABB.Width - ScreenHalfWidth, v.X))
	v.Y = Max(ScreenHalfHeight, Min(TileMap.MapAABB.Height - ScreenHalfHeight, v.Y))
	' Finale Screen Koordinaten
	Return v
End Sub

Public Sub myTransform(GS As X2GameStep,  mbw As X2BodyWrapper)
	'

'	
	Dim Rhombus As BCPath
	Dim p5, p6, p7, p8 As B2Vec2

	Dim f As B2Fixture = mbw.Body.FirstFixture

	Dim HalfWidth As Float = mbw.X2.GetShapeWidthAndHeight(f.Shape).X/2
	Dim HalfHight As Float =  mbw.X2.GetShapeWidthAndHeight(f.Shape).Y/2


	Dim p1 As B2Vec2 = X2.WorldPointToMainBC(mbw.Body.Position.X-HalfWidth, mbw.Body.Position.Y-HalfHight)
	Dim p2 As B2Vec2 = X2.WorldPointToMainBC(mbw.Body.Position.X+HalfWidth, mbw.Body.Position.Y-HalfHight)
	Dim p3 As B2Vec2 = X2.WorldPointToMainBC(mbw.Body.Position.X+HalfWidth, mbw.Body.Position.Y+HalfHight)
	Dim p4 As B2Vec2 = X2.WorldPointToMainBC(mbw.Body.Position.X-HalfWidth, mbw.Body.Position.Y+HalfHight)

	Punkte(p1, p5)
	Punkte(p2, p6)
	Punkte(p3, p7)
	Punkte(p4, p8)
	'

	Rhombus.Initialize(p1.X, p1.Y).LineTo(p2.X, p2.Y).LineTo(p3.X,p3.Y).LineTo(p4.X,p4.Y)
	GS.DrawingTasks.Add(X2.MainBC.AsyncDrawPath(Rhombus.Clone, BrushLineColor1, True, 5))

	
End Sub


Private Sub Punkte(PunktOriginal As B2Vec2, PunktTranform As B2Vec2)
	
	PunktTranform.X = PunktOriginal.X 
	PunktTranform.Y = PunktOriginal.Y - 20
End Sub



Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub



Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = PanelForTouch.TOUCH_ACTION_DOWN Then

	else If Action = PanelForTouch.TOUCH_ACTION_UP Then
		
	End If
End Sub